/*
True Comp Duplicator Alternative Script for After Effects
*/

(function duplicateCompWithDependencies() {
    var activeComp = app.project.activeItem;

    if (!(activeComp && activeComp instanceof CompItem)) {
        alert("Bitte öffne eine Komposition und wähle sie aus, bevor du das Skript ausführst.");
        return;
    }

    app.beginUndoGroup("Duplicate Comp with Dependencies");

    // Map to track duplicated items
    var duplicatedItems = {};

    // Function to duplicate a composition and its dependencies
    function duplicateComp(comp) {
        if (duplicatedItems[comp.id]) {
            return duplicatedItems[comp.id]; // Return already duplicated comp
        }

        var newComp = comp.duplicate();
        newComp.name = comp.name + "_Copy";
        duplicatedItems[comp.id] = newComp;

        // Loop through layers to duplicate nested comps
        for (var i = 1; i <= newComp.numLayers; i++) {
            var layer = newComp.layer(i);

            if (layer.source && layer.source instanceof CompItem) {
                var duplicatedSource = duplicateComp(layer.source);
                layer.replaceSource(duplicatedSource, false);
            }
        }

        return newComp;
    }

    // Duplicate the active comp
    var duplicatedComp = duplicateComp(activeComp);

    alert("Komposition erfolgreich dupliziert: " + duplicatedComp.name);

    app.endUndoGroup();
})();
